

'                Band by jimv
'      AD&Dv1 Variant NPC Band Generator


DIM pl(20)
DIM l(20)

RANDOMIZE (TIMER / 2)

REM interpret command line
cc$ = COMMAND$
IF cc$ = "" GOTO 8
REM argument present
a = LEN(cc$)
b1$ = LEFT$(cc$, 1)
IF b1$ = "D" OR b1$ = "H" GOTO 2
IF ASC(b1$) >= 49 AND ASC(b1$) <= 57 GOTO 2
GOTO 8
2 REM okay so far - find b2 (length of argument)
b2 = INSTR(cc$, " ")
b3 = INSTR(cc$, ">")
IF b3 = 0 GOTO 3
REM redirected output
IF b2 = 0 THEN b2 = b3
IF b2 <> 0 AND b3 < b2 THEN b2 = b3
GOTO 4
3 REM screen output
IF b2 = 0 THEN b2 = a + 1
4 b2 = b2 - 1
REM length known - get argument (b4$)
b4$ = LEFT$(cc$, b2)
b5 = LEN(b4$)
IF b4$ = "HELP" GOTO 9
IF b1$ = "H" GOTO 8
REM count non-numbers
b6 = 0
FOR a = 1 TO b5
b7$ = MID$(b4$, a, 1)
IF ASC(b7$) < 48 OR ASC(b7$) > 57 THEN b6 = b6 + 1
NEXT a
IF b6 > 1 GOTO 8
IF b6 = 0 GOTO 6
REM random argument
IF b1$ <> "D" GOTO 5
REM d1 is implicit
d1 = 1
d2 = VAL(RIGHT$(b4$, b5 - 1))
GOTO 10
5 REM d1 is explicit
b8 = INSTR(b4$, "D")
d1 = VAL(LEFT$(b4$, b8 - 1))
d2 = VAL(RIGHT$(b4$, b5 - b8))
GOTO 10
6 REM non-random argument
d2 = 1
d1 = VAL(b4$)
GOTO 10

8 REM bad command line
PRINT
PRINT "Command Line Format:"
PRINT
PRINT "        band <# appearing>"
PRINT
PRINT "Examples:"
PRINT
PRINT "        band 30              30 band members"
PRINT "        band d10             1-10 band members"
PRINT "        band 3d6             3-18 band members"
PRINT "        band 3d6 > file      sends 3-18 band members to 'file'"
PRINT "        band help            helpful information"
PRINT
END

9 REM help
SHELL "type band.hlp | more"
END

10 REM run program
PRINT
a = INSTR(b4$, "D")
IF a = 0 GOTO 11
b4$ = LEFT$(b4$, a - 1) + "d" + RIGHT$(b4$, LEN(b4$) - a)
11 PRINT "Random Band ("; b4$; ")"
PRINT

REM read data
FOR a = 1 TO 3
READ c$(a), pc(a), chd(a), thl(a)
NEXT a
FOR a = 1 TO 11
READ pl(a), l(a)
NEXT a

REM number appearing
FOR a = 1 TO d1
r = INT(RND * d2) + 1
na = na + r
NEXT a

REM begin big loop
FOR x = 1 TO na

REM find class and level
GOSUB 100
FOR a = 1 TO 3
IF p >= pc(a) THEN cl$ = c$(a)
IF p >= pc(a) THEN hd = chd(a)
IF p >= pc(a) THEN tha = thl(a)
NEXT a
GOSUB 100
FOR a = 1 TO 11
IF p >= pl(a) THEN lv = l(a)
NEXT a
IF lv = 16 THEN lv = INT(RND * 6) + 11

20 REM find basic stats
GOSUB 180
str = p
GOSUB 100
str2 = p
IF cl$ <> "Fighter" OR str <> 18 THEN str2 = 0
GOSUB 180
dex = p
GOSUB 180
con = p
GOSUB 180
wis = p
IF cl$ = "Fighter" AND (str < 9 OR con < 7) THEN GOTO 20
IF cl$ = "Thief  " AND dex < 9 THEN GOTO 20
IF cl$ = "Mage   " AND wis < 13 THEN GOTO 20

REM find a1 = hit dice
a1 = lv
IF cl$ = "Thief  " AND a1 > 10 THEN a1 = 10
IF cl$ = "Fighter" AND a1 > 9 THEN a1 = 9

REM find a4 = non-random hp
IF cl$ = "Fighter" THEN a2 = 3
IF cl$ = "Thief  " THEN a2 = 2
IF cl$ = "Mage   " THEN a2 = 0
a3 = lv - a1
IF a3 < 0 THEN a3 = 0
a4 = a2 * a3

REM find hp
hp = 0
FOR a = 1 TO a1
r = INT(RND * hd) + 1
IF con = 3 THEN r = r - 2
IF con = 4 OR con = 5 THEN r = r - 1
IF con = 15 THEN r = r + 1
IF con = 16 THEN r = r + 2
IF con > 16 AND cl$ <> "Fighter" THEN r = r + 2
IF con = 17 AND cl$ = "Fighter" THEN r = r + 3
IF con = 18 AND cl$ = "Fighter" THEN r = r + 4
IF r < 1 THEN r = 1
hp = hp + r
NEXT a
hp = hp + a4

REM find thaco
th = 20 - INT((lv - 1) / tha)
th1 = th
th2 = th
IF str = 3 THEN th1 = th1 + 3
IF str = 4 OR str = 5 THEN th1 = th1 + 2
IF str = 6 OR str = 7 THEN th1 = th1 + 1
IF str = 17 OR str = 18 THEN th1 = th1 - 1
IF str2 >= 51 THEN th1 = th1 - 1
IF str2 = 100 THEN th1 = th1 - 1
IF dex = 3 THEN th2 = th2 + 3
IF dex = 4 THEN th2 = th2 + 2
IF dex = 5 THEN th2 = th2 + 1
IF dex = 16 THEN th2 = th2 - 1
IF dex = 17 THEN th2 = th2 - 2
IF dex = 18 THEN th2 = th2 - 3

REM find damage bonus
db1 = 0
db2 = 0
IF str < 16 AND str > 5 THEN GOTO 40
IF str <= 5 THEN db1 = -1
IF str = 16 OR str = 17 THEN db1 = 1
IF str = 18 AND cl$ <> "Fighter" THEN db1 = 2
IF str2 = 0 THEN GOTO 40
db1 = 3
IF str2 >= 76 THEN db1 = 4
IF str2 >= 91 THEN db1 = 5
IF str2 = 100 THEN db1 = 6

40 REM find ac
IF cl$ = "Fighter" THEN ac = INT(RND * 4) + 6 - INT(lv / 2)
IF cl$ = "Thief  " THEN ac = 8
IF cl$ = "Mage   " THEN ac = 10
IF ac = 9 THEN ac = 10
IF ac = 10 THEN item2$ = "no"
IF ac = 8 THEN item2$ = "le"
IF ac = 7 THEN item2$ = "st"
IF ac = 6 THEN item2$ = "sc"
IF ac = 5 THEN item2$ = "ch"
IF ac = 4 THEN item2$ = "sp"
IF ac < 3 THEN ac = 3
IF ac = 3 THEN item2$ = "pl"
item3$ = "-"
IF cl$ = "Mage   " THEN GOTO 42
IF cl$ = "Thief  " THEN GOTO 42
GOSUB 100
IF p <= 50 THEN item3$ = "@"
IF p <= 50 THEN ac = ac - 1
42 REM DEX mod to AC
IF dex = 3 THEN ac = ac + 4
IF dex = 4 THEN ac = ac + 3
IF dex = 5 THEN ac = ac + 2
IF dex = 6 THEN ac = ac + 1
IF dex = 15 THEN ac = ac - 1
IF dex = 16 THEN ac = ac - 2
IF dex = 17 THEN ac = ac - 3
IF dex = 18 THEN ac = ac - 4

REM melee weapon
itemb$ = "-"
item1$ = "-"
GOSUB 100
IF cl$ = "Mage   " THEN item1$ = "d"
IF cl$ = "Mage   " THEN GOTO 44
IF cl$ = "Thief  " AND p <= 50 THEN item1$ = "s"
IF cl$ = "Thief  " AND p > 50 THEN item1$ = "l"
IF cl$ = "Thief  " AND p > 75 THEN item1$ = "d"
IF cl$ = "Thief  " THEN GOTO 43
IF item3$ = "@" THEN item1$ = "l"
IF item3$ = "@" THEN GOTO 44
IF p <= 50 THEN item1$ = "l"
IF p > 50 THEN item1$ = "t"
IF p > 50 THEN GOTO 44

43 REM missile weapon
GOSUB 100
IF p <= 50 THEN itemb$ = "a"

44 REM find magic armor
GOSUB 200
IF mgk = 0 THEN GOTO 45
IF item2$ = "le" THEN item2$ = "LE"
IF item2$ = "st" THEN item2$ = "ST"
IF item2$ = "sc" THEN item2$ = "SC"
IF item2$ = "ch" THEN item2$ = "CH"
IF item2$ = "sp" THEN item2$ = "SP"
IF item2$ = "pl" THEN item2$ = "PL"
ac = ac - 1
IF item2$ = "no" THEN item2$ = "B"
IF item2$ <> "B" THEN GOTO 45
GOSUB 100
item2$ = "B8"
IF p >= 6 THEN item2$ = "B7"
IF p >= 16 THEN item2$ = "B6"
IF p >= 36 THEN item2$ = "B5"
IF p >= 51 THEN item2$ = "B4"
IF p >= 71 THEN item2$ = "B3"
IF p >= 86 THEN item2$ = "B2"
ac = ac - (9 - VAL(RIGHT$(item2$, 1)))

45 REM find magic shield
GOSUB 200
IF mgk = 0 THEN GOTO 46
IF item3$ = "@" THEN item3$ = "*"
IF item3$ = "*" THEN ac = ac - 1

46 REM find magic melee weapon
GOSUB 200
IF mgk = 0 THEN GOTO 47
IF item1$ = "d" THEN item1$ = "D"
IF item1$ = "s" THEN item1$ = "S"
IF item1$ = "l" THEN item1$ = "L"
IF item1$ = "t" THEN item1$ = "T"
th1 = th1 - 1
db1 = db1 + 1

47 REM find magic missile weapon
GOSUB 200
IF mgk = 0 THEN GOTO 48
IF itemb$ = "a" THEN itemb$ = "A"
IF itemb$ = "A" THEN th2 = th2 - 1
db2 = db2 + 1

48 REM Weapon Proficiency
spec1$ = "P"
spec2$ = "-"
IF cl$ <> "Mage   " OR lv >= 6 THEN spec2$ = "P"
IF cl$ <> "Fighter" THEN GOTO 55
prof = 4 + INT(lv / 3)
IF itemb$ = "a" OR itemb$ = "A" THEN GOTO 50
REM non-archers
spec1$ = "D"
prof = prof - 3
IF prof = 1 THEN spec2$ = "P"
IF prof >= 2 THEN spec2$ = "S"
GOTO 51
50 REM archers
spec2$ = "S"
prof = prof - 2
IF prof = 1 THEN spec1$ = "P"
IF prof = 2 THEN spec1$ = "S"
IF prof >= 3 THEN spec1$ = "D"
51 REM melee specialization benefits
IF spec1$ = "S" THEN th1 = th1 - 1
IF spec1$ = "S" THEN db1 = db1 + 2
IF spec1$ = "D" THEN th1 = th1 - 3
IF spec1$ = "D" THEN db1 = db1 + 3

55 REM damage potential
dmg1$ = "0"
dmg2$ = "0"
IF item1$ = "d" OR item1$ = "D" THEN dmg1$ = "4"
IF item1$ = "s" OR item1$ = "S" THEN dmg1$ = "6"
IF item1$ = "l" OR item1$ = "L" THEN dmg1$ = "8"
IF item1$ = "t" OR item1$ = "T" THEN dmg1$ = "10"
IF itemb$ = "a" OR itemb$ = "A" THEN dmg2$ = "6"

60 REM print
PRINT USING "##) "; x;
PRINT cl$;
PRINT USING " ##  "; lv;
PRINT item1$;
PRINT itemb$;
PRINT item2$;
PRINT item3$;
PRINT " ";
PRINT spec1$; "/"; spec2$;
PRINT "  ";
IF dmg1$ = "0" THEN PRINT "-----";
IF dmg1$ = "0" THEN GOTO 62
PRINT "d"; dmg1$;
IF db1 = 0 THEN PRINT "  ";
IF db1 = 0 THEN GOTO 61
IF db1 > 0 THEN PRINT "+";
IF db1 > 0 THEN PRINT USING "#"; db1;
IF db1 < 0 THEN PRINT USING "##"; db1;
61 IF dmg1$ <> "10" THEN PRINT " ";
62 PRINT "/";
IF dmg2$ = "0" THEN PRINT "----";
IF dmg2$ = "0" THEN GOTO 63
PRINT "d"; dmg2$;
IF db2 = 0 THEN PRINT "  ";
IF db2 = 0 THEN GOTO 63
IF db2 > 0 THEN PRINT "+";
IF db2 > 0 THEN PRINT USING "#"; db2;
IF db2 < 0 THEN PRINT USING "##"; db2;
63 PRINT " ";
PRINT USING "hp=##"; hp;
PRINT USING " th=##/##"; th1; th2;
IF ac < 0 OR ac > 9 THEN PRINT USING " AC##"; ac;
IF ac >= 0 AND ac <= 9 THEN PRINT USING " AC#"; ac;
IF str >= 16 THEN PRINT USING " S##"; str;
IF str <= 7 THEN PRINT USING " S#"; str;
IF str2 = 0 GOTO 65
PRINT "/";
IF str2 = 100 THEN str2 = 0
IF str2 < 10 GOTO 64
PRINT USING "##"; str2;
GOTO 65
64 PRINT "0";
PRINT USING "#"; str2;
65 IF dex >= 15 THEN PRINT USING " D##"; dex;
IF dex <= 6 THEN PRINT USING " D#"; dex;
IF con >= 15 THEN PRINT USING " C##"; con;
IF con <= 6 THEN PRINT USING " C#"; con;
IF cl$ = "Mage   " THEN PRINT USING " W##"; wis;
PRINT

REM dash-cut
IF x MOD 5 <> 0 GOTO 70
IF x = na GOTO 70
PRINT STRING$(70, 45)

70 REM end big loop
NEXT x
PRINT
END

100 REM d100
p = INT(RND * 100) + 1
RETURN

180 REM 3d6
p = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
RETURN

200 REM magic?
p = INT(RND * 100) + 1
magper = lv ^ 2
mgk = 0
IF p <= magper THEN mgk = 1
IF p <= 5 THEN mgk = 1
IF p > 95 THEN mgk = 0
RETURN
                 
DATA "Fighter",1,10,1
DATA "Thief  ",81,6,2
DATA "Mage   ",96,4,3
DATA 1,1,26,2,46,3,61,4,72,5,80,6,86,7,91,8,95,9,98,10,100,16



