Newsgroups: mlist.adnd-l
Path: nntp-server.caltech.edu!nntp-server.caltech.edu!
From: MGL4%PSUVM.bitnet@UTARLVM1.UTA.EDU (The Doppleganger 814-237-9654)
Subject: New Character Class
Message-ID: <9205201733.AA11643@tybalt.caltech.edu>
Sender: news@nntp-server.caltech.edu
Original-To: Multiple recipients of list ADND-L <ADND-L@UTARLVM1.UTA.EDU>
Reply-To: The Doppleganger 814-237-9654 <MGL4%PSUVM.bitnet@UTARLVM1.UTA.EDU>
Organization: California Institute of Technology, Pasadena
Distribution: mlist
Date: Wed, 20 May 1992 17:29:00 GMT
Approved: mlist.adnd-l@nntp-server.caltech.edu

Greetings fellow list members,

 I have been a member of this discussion gourp for about 5 months
now, but until now I have been non-active (except of personal replys).  I
have enjoyed the discussions that I have been reading and find most of the
postings insightful and helpful.  With the advent of the summer season
here in the northern hemisphere, I find myself with more time and would
like to shake some of the house rules that have been developed by my
friend and DM, Hugh Barnes.  I have gained his permission to post some of
the character classes, spells, armor system and other ideas he has
produced over his many years of playing AD&D.  I welcome discussion on
anything that I post, public or private, as this will serve to improve the
over all quality of the work.  Thank you in advance.

 I guess the first thing I would like to introduce is a character class
that I found to be very fun to play.  It is called the Delver.  Hugh and I
have never come up with a good historical equivalent to the Delver class,
the best we can come up with (and these are not quite appropriate) is the
Delver is like a Indiana Jones or Sherlock Holmes type character...Hmmm,
we'll let you decide if these are appropriate.


                  DELVER CHARACTER CLASS

 The Delver is a expert adventurer.  He is trained in the skills
essential for solving mysteries and getting through obstacles while still
keeping himself in one piece.  While other classes are easily more powerful
than the Delver in their respective fields, none of them are as widely
qualified for over-all adventuring.

     REQUIREMENTS

1. The Delver may be of any race, but not split-class.

2. Because of the physical and mental demands of the class, a Delver
must have a minimum score of 9 in both dexterity and intelligence.  A
Delver with 15 or more in both dexterity and intelligence gains a 10%
bonus to experience.

     GENERAL DETAILS

1. Because of superior physical training, a Delver gets 1d8 hit points
per level.

2. Because of an emphasis on self defense, Delvers are qualified
combatants, and strike as clerics.

3. A Delver may train in any weapon available to thieves.  They get 3
proficiency slots, and advance 1 slot per 4 levels.

4. Because of his many perks and abilities (see below) the Delver gets
fewer non-weapon proficiencies then other classes (reflects all the
advanced training they had to become Delvers).  So a reasonalble start
is 2 initial non-weapon proficiencies slots, and advance 1 slot per 3
levels.

5. A Delver can wear any armor, but any armor better then studded
leather will make the use of certain skills very hard if not impossible.
They perfer to go without.

6. Delvers make saving throws as thieves.

     DELVER SKILL DETAILS

1. Delvers are trained to spot secret doors, and if actively looking,
they will spot them 20% of the time (33% for elves and half-elves) and
improve +5% for each level after first, up to a maximum of 80%.

2. Delvers are trained in first aid, and can bind themselves and their
companions for 1d3+1 hit points at first level.  The die for this
increases by 1 for each odd level, thus:  level 3 the roll is 1d4+1...
level 5 = 1d5+1.  Up to level 9 = 1d7+1 (perhaps 1d8+1, since it is
hard to find seven sided die).  The binding is only good against
injuries that involve physical harm, not magical damage...that is a Delver
can bind a sword wound but not a magic missile wound (use your discretion
on judging the wound).  And the Delver can only bind once per injury...
that is you can't bind the same wound twice.

3. Delvers are experts in dealing with toxins and diseases.  If one
devotes attention to a person requiring a save versus poison or a
resistance to disase, the delver can confer a +1 (5%) for each third level
he has achieved. This includes self-treatment. This starts at a base of +1
and progresses no further than +5.

4. Delvers dabble in magic, and keep a spellbook.  They can memorize
one first level spell per level after first level, that is one first level
spell when he attains second level (there is no guarantee of abtaining the
spell, they must work, buy or bargain for the spell).  They can never cast
anything higher than first level spells (except off scrolls). Dwarves
cannot cast spells unless the DM permits them to.  Gnomes can only use
illusions unless the DM declares otherwise.

5. Delvers have the thieving abilities of climbs walls, open lock, detect
noise, and find/remove trap.  (In the case of find/remove trap, the Delver
is not limited to small devices.  Though he cannot remove large traps, he
can find a way to bypass them, if it is possible.  Small devices can be
removed or broken as normal.)  **First edition PHB values are the same.
For second edition PHB he starts with normal +32 discretionary points, and
each level after first he gets +16.  No more then half to be used in any one
skill**.

*6. Delvers are experienced to some extent with so many written
languages that there is a chance (unless the DM rules it too exotic) for him
to read any given text.  Even if he can't read it, he has a good chance of
identifying what language he is looking at.  He has no ability in speaking,
and little ability in comprehending, spoken languages other than those he
is proficient in.
A. Base chance to read language equals intelligence as a %.
B. Identify language equals base x 2.
C. Comprehend language equals base/2 to identfy the language (unless it
   is obvious), and another base/3 to understand it.

*7. Delvers are well read in histories, mythologies, folklore and the like
(we called this skill Legend Lore).  Because of this, they have a chance to
recall names, facts and rumors about people, objects, names, creatures or
what have you (as long as it isn't too mundane or exotic).  His base chance
is 5%.  He also chooses a specific subject to specialize in (such as a
specific race, culture...), for which his base knowledge is 20%.

*8. Delvers are exceptionally good judges of the nature, origin,
composition, value and properties of objects, thus there is a chance (unless
the object is too mundane or too exotic) that he can reveal what an object
is, who (in general) made it, what it is made of, and how much it is worth
(hence we deemed this skill the Object Appraisal skill).  He can also
reveal curses, and other magical energies (school or sphere, and how strong,
but not exact effects).  He does not need to touch the object to do this.
His base chance is 5%.  He also gets a specific area of speciality (like
armor or jewelry...) in which his base knowledge is 20%.  For each point of
intelligence the Delver has over 14, add one to these base chances.

* These abilities are augmented by the distribution of 12 discretionary
points per level after the first, no more than half going to any one ability.
(note that the points that go to Legend Lore or Object Appraisal go to both
the base and the specialty area...that is at second level: you decide to
devote +4 points to Legend Lore, the skill becomes 9% for general Legend Lore
skill and 24% for the area of speciality)

Level      Experience
  1         0 - 1,750
  2     1,751 - 3,500
  3     3,501 - 7,000
  4     7,001 - 14,000
  5    14,001 - 26,000
  6    26,001 - 50,000
  7    50,001 - 85,000
  8    85,001 - 120,000
  9   120,001 - 180,000
 10   180,001 - 250,000

250,000 EXP and +2 HP for each level after 10th

 Well, that is about it for the Delver.  My experience in playing the
character class was good.  It is a great class for small groups, where it is
hard to fill the gaps in character class skills, since the Delver has some
limited abilities in healing, spell casting and thieving skills.  The class
was originally designed for a low level, low magic campaign wehre problem
solving, mystery-uncovering are emphasised over hack'em-slash'em, so I
found the Legend Lore and Object Appraisal skill most helpful in finding
clues and leads.  Try it out!

 Thanks much for your attention
 Michael LeSeney

====================================================================

Michael LeSeney              Bitnet:    mgl4@psuvm
A.K.A. The Doppleganger      Internet:  mgl4@psuvm.psu.edu
                             Alternate: leseney@psumeteo.psu.edu

Stone and Sea are deep in life,
two unalterable symbols of the world:
permanence at rest, and permanence in motion;
participants in the Power that remains.          S.R. Donaldson
=====================================================================

