From news.u.washington.edu!usenet.coe.montana.edu!caen!uunet!capitol!thomas Tue Sep 15 16:10:35 PDT 1992


Someone mentioned the Shifter class that went by a month or so ago. Here it
is again. This is an older version, but the most up to date is at home, so
this will have to do. Please direct comments to me ;)

Character Class:   Shifter

Ability Requirement:     Constitution 15,  Wisdom 12
Prime Requisite:         Constitution
Races Allowed:           Human, Elf, Half-elf

     Shifters are characters that have the ability to change
their form at will.  They are generally nature oriented.  Only
humans, elves and half-elves can be shifters.
     Constitution is the prime requisite of a shifter since
changing ones basic matter is strenuous.  Wisdom is also
important as shifters must have a certain spiritual equilibrium
to be able to shift.  A shifter with a constitution of 16 or more
gains a 10% bonus to the experience he earns.  A shifter also
gains bonus hit points based on constitution as a fighter does
(+3 for 17, + 4 for 18.)  Constitution also gives a bonus to the
number of forms a shifter can assume and a bonus to the number of
shift points.
     Shifters must be chaotic in alignment.  They can be good,
neutral or evil.
     Shifters are fairly hardy fighters though they are limited
to common types of weapons (basic swords, staves, daggers, etc.) 
A shifter generally prefers to shift to a form to fight. 
Shifters generally avoid using metallic implements, preferring
natural materials since they are easier to shift.  For this
reason, shifters almost never wear metallic armor.  They will
frequently wear leather, however.  Shifters can use shields.
   Shifters make saving throws as a priest and determine their
THAC0 as a priest.

     In addition to their shifting ability, shifters have the
following abilities:
     *    Animal empathy
     *    Can always recognize another shifter, no matter what
          form is being assumed.
     *    Has a 10% per level chance of recognizing any
          polymorphed entity.
     *    Has a 10% per level resistance to being polymorphed,
          petrified or transformed in some other way.
     *    A shifter can naturally heal himself when using his
          shifting power.  Hit points are regained at the rate of
          X percent of the shifter's total hit points for every
          shift point used where X is determined by level.  The
          healing works the same whether a form is assumed or
          not.
     *    A shifter gets a saving throw bonus versus poison of +1
          for every three levels he attains.
     *    A shifter gets a saving throw bonus versus disease of
          +1 for every three levels he attains.
     *    At 5th level a shifter gains the ability to "read"
          other beings (see below).
     *    At 10th level a shifter can initiate another person to
          make them a shifter.

     Shifters have a certain magical nature and to become a
shifter you must be initiated by a high level shifter.  Shifters
are not very common.  A shifter starts out with the ability to
shift to 2 forms (not counting constitution bonuses.)  He must
bond with those forms before he can shift to them.
     Shifting is obviously the most important ability of the
shifter.  There are two types of shifts a shifter can perform, a
fixed-form shift and a free-form shift.
     In a fixed form shift, the shifter shifts to some
"memorized" form and takes on all the (non-magical) attributes of
that form.  It is a complete transformation with the exception of
the shifters mind and hit points.  The shifter can use all the
natural abilities of the being who's form he wears.  For example,
if a shifter becomes a red dragon, he would not get its breath
weapon but he would get its natural attacks (bite, claws, etc.) 
Before a shifter can shift to a fixed form he must "bond" with
that form.  This is explained later.  Once shifted, a shifter can
maintain the form indefinitely, until another shift is performed.
All shifts have a cost, including shifting back to the shifters
natural form, though shifting to his natural form only costs
half.  A shifter has a limited number of fixed forms he can shift
to based on his level and constitution bonus.
     A free form shift is very different than a fixed form shift. 
There is no "memorized" model on which the shift is based, though
parts of the shift may be based on a bonded model.  Free form
shifting is actually more strenuous than fixed form since there
is no bond to a specific form.  A free form shift is limited only
by the shifters imagination, and his shift point limit.  A
shifter could turn his hands into tigers claws and grow giant
eagles wings.  He could turn his arms into bone swords, harden
his skin, or turn himself into a squishy pancake and slither
under a door.  He could also turn himself into the semblance of
another humanoid or more bizarre creature.  Free form shifts do
not last for an indefinite time.  They require a cost to maintain
and, if not maintained, the shifter will revert to his natural
form.

     The most important factor in the cost of a shift is the mass
to be shifted.  Both the quantity of mass and the type of mass
have an effect on the cost.  The cost of a shift can be found on
the following table:
   The base cost is for a change of mass of not less than 50% of
the shifters total mass and not more than 200% of his total mass. 
For every decrease in mass of 50% there is an additional 1 SP
cost for fixed-form and 2 SP for free-form.  So, if a shifter
wanted to change to something between 1/8th and 1/16th his mass
it would cost an additional 3 SP.  The reverse is true for
increasing mass for every 100% increase in total mass.
     There is a cost of 1 SP for each extra 20 pounds of animal
material to be shifted.  This is a one time cost which applies
only to shifting from the shifters true form.  The extra mass is
counted as part of the base mass to be shifted.  So, if a shifter
weighed 150 lbs and was carrying 15 lbs of animal material he
wanted to shift he would have to pay an extra SP for the extra
animal material and his base mass would be 165 lbs.
     If the shifter is carrying plant matter he wishes to shift
he must pay 1 SP if there is less than 10 lbs of vegetable
material or 2 SP for every 10 lbs of vegetable material.  The
costs are doubled for free-form shifts.
     The cost for shifting mineral material is high which is why
shifters generally don't carry much minerals and metals.  If the
shifter is carrying less than 1 lb of mineral he must pay 1 SP
for a fixed-form shift and 2 for a free-form shift.  If he is
carrying 1 or more pounds the cost is 2 SP per pound for a free-
form shift and 4 SP per pound for fixed-form.
     In addition to the type of mass being shifted there is one
other consideration.  Are the items to be shifted magical in
nature.  Shifting magic items is possible but incurs an extra
cost.  The shifter must pay 1 SP for every +1 the item possesses
for a free-form shift and double that for a fixed-form.  Shifting
minor magic which doesn't possess pluses costs 1 SP per item.  In
addition, the shifter can incorporate the magic in the item into
his new being by doubling the cost of shifting the item.  Whether
a shifted magic item can be used is entirely up to the DM.
     When performing a free-form shift, the severity of the
change has an impact on the cost as well as the mass.  A minor
change such as changing pigmentation, hardening the skin,
slightly changing features (smaller ears, bigger nose, etc.)
costs 1 SP per change.  Minor changes are mainly cosmetic.  If
there are more than two minor changes it is just considered a
major change.  Changing from one humanoid form to another would
cost a maximum total of 6 or 7 points (not counting shifting
mineral, vegetable or magic material.)
     A major change involves a change in the shifters basic
nature.  For instance growing wings or changing your arms to bone
swords or tigers claws would be major changes.  If there are more
than two major changes it is just counted as a drastic change.
     A drastic change would be a change in nature to something
really bizarre.  For instance, turning into a squishy, flesh
pancake to slither under a door is a drastic change or growing
huge bat wings, tiger claws, and a lizard's tail would be a
drastic change.
     If part of a free-form shift is to a form that is part of a
bonded form for the shifter, subtract 1 SP from the cost of the
change.  For instance, if the shifter has a bonded form of a
tiger and shifts his hands to tiger claws the additional cost
would only be 2 SP (3 SP for major change - 1 SP for bonded
form.)
     The maintenance cost of a free-form is one half the shifting
cost per turn.  There is no maintenance cost for the first turn. 
There is no cost to return to the shifters true form when
performing a free-form shift.  However, shifting from a fixed-
form costs one half of what it would cost to shift to that form
from the shifters true form.
     A shifter does not have to return to his true form to shift
to another form.  However, the cost of shifting is from whatever
form the shifter is currently in.
     Shifting does take a certain amount of time.  At first level
it takes a full round to make a shift.  It takes one segment less
per level over first until 10th level is reached and it takes
only 1 segment to make a shift.

     As stated above, a shifter must bond with an entity before
he can perform a fixed-form shift to that creature.  To bond with
a being the shifter must be in contact with the being for 1 turn
minus one round for every level over 1st.  Once one round is
reached, subtract one segment of time per level.  The bonding
never takes less than one segment.
     During the time the shifter is in contact with the being, he
is in a state of meditation and is "reading" and "memorizing" the
being's basic nature.  In order for this to work properly, the
being must be alive.  The shifters animal empathy comes in very
handy for this process.
     There is a possibility to bond with a creature that has only
recently died.  The creature must have been dead less than one
half of an hour.  If it has been dead longer than that there is
no chance of bonding.  If the shifter attempts to bond with a
dead creature there is a chance that the bonding will not work
properly.  There is also a chance that the shifter will die.  The
chance of a successful bonding is 70% - 2% for every minute the
creature has been dead.  Whether the bonding is successful or
not, the shifter must make a system shock check.  If he fails, he
dies.  The shifter also loses that bonding "slot" whether the
bonding is successful or not.
     A bonding costs the number of points it would cost to shift
to the creature being bonded if it were bonded (not counting the
costs of any equipment or clothes being worn.)
     The reading ability of a shifter is very similar to a bond. 
The shifter must touch the being and by doing so can "read" the
being's physical nature.  This new knowledge can be used in
making shifts and can also be useful for informational purposes. 
The general health of a creature could be determined by reading
it as well as specific ailments.  Note that no bond is made when
a reading is performed.  If a shifter shifts to a form he has
read it is a free-form shift.
     As stated before, shifting requires concentration to enact. 
In combat, a shift counts as the players action, just as casting
a spell counts as a mages action.  When shifting a shifter does
not gain his dexterity bonus for armor class.  In addition, if a
shifter is hit and takes damage during a shift, the damage is
applied to the form being shifted to.  The healing ability can
not reduce damage that occurs once the shift is in progress.
     Regardless of how quickly a shifter can shift, he can shift
no more than once per round.

Proficiencies:
     Shifters start with two weapon proficiencies and gain one
every five levels.  They have a non-proficiency penalty of -3.
     Shifters start with 3 non-weapon proficiencies and gain one
every three levels.  Shifters can use non-weapon proficiencies
from the general, warrior, and rogue categories.


CHARTS:


Level  Exp pts.  Hit  Shift   Total  Heal Recognize Poison Disease
                 Dice Points  forms  Per  & resist   save    save
                                     SP   polymorph  bonus  bonus
  1    0          1     2       2    2%    10%         0       0
  2    1600       2     4       3    4%    20%         +1      0
  3    3200       3     7       3    6%    30%         +1      +1
  4    6400       4    11       4    8%    40%         +2      +1
  5    16000      5    16       5    10%   50%         +2      +1
  6    32000      6    22       5    12%   60%         +3      +2
  7    64000      7    29       6    14%   70%         +3      +2
  8    120000     8    37       7    15%   80%         +4      +2
  9    224000     9    46       7    16%   90%         +4      +3
 10    464000    +1   +10       8    17%   95%         +5      +3
 11    +240000   +1   +10      +1    +1%   99%         +5      +3


Shift Costs:

                    Fixed-Form               Free-Form
Base Cost                1                        3
Each 50% decrease        1                        2
Each 100% increase       1                        3
Each extra 20 lbs        1                        1
   animal material
Under 10 lbs vegetable   1                        2
Each 10 lbs vegetable    2                        4
Under 1 lb mineral       1                        3
Each 1 lb of mineral     2                        4
Each +1 of magic item    1                        2
  To use each +1 magic   1                        2
Miscellaneous minor      1                        2
   magic
Each minor change        n/a                      1
Each major change        n/a                      3
Drastic change           n/a                      7
Each part of change to   n/a                      -1
   a bonded form


Constitution Bonus:

Constitution   Bonus     Bonus
               Forms     Points
     15        0         0
     16        1         1 every other level
     17        2         1 every level
     18        3         2 every level


Shift Point Recovery:

               1  2  3  4  5  6  7  8
Sleep          0  1  3  6  15 30 50 90
Rest           0  0  1  2  4  12 25 40
Light Activity 0  0  0  1  1  3  9  20
Moderate Act.  0  0  0  0  1  1  1  2
-- 
Mark A. Thomas (thomas@capitol.com)	Capitol Disc Interactive
202-625-0187/202-965-7800		2121 Wisconsin Ave. NW
I speak for myself only			Washington, D.C.  20007
In the end, everything degenerates to specifics.


