Path: nntp-server.caltech.edu!elroy.jpl.nasa.gov!swrinde!cs.utexas.edu!utgpu!cunews!nrcnet0!bnrgate!bigsur!bnr-rsc!chekov.UU.NET!spencer
From: spencer@chekov.UU.NET (Chris Spencer)
Newsgroups: rec.games.frp
Subject: Alignments (or The Gospel According To Jon)
Message-ID: <7522@bnr-rsc.UUCP>
Date: 27 Feb 92 22:43:37 GMT
Sender: news@bnr-rsc.UUCP
Reply-To: spencer@chekov.UU.NET (Chris Spencer)
Distribution: na
Organization: Northern Telecom, Ottawa, Canada
Lines: 257

*** WARNING: this article is 270 lines loooonnnngggg! ***

I am posting this for a friend.  Respond with any comments you may have
to rec.games.frp only (not me).

Not Jon

~Subject: Alignments
~Date: Fri, 31 Jan 92 13:57:15 EST

The Gospel According to Jon:

One of the most frequent problems that I have experienced in aD&D
(both as a player and a DM) is the concept of alignments and how to
play them or adjudicate them (as a DM).  One of the key problems to
the issue is that frequently, DMs and his/her players will have
diametrically opposing views concerning several of the more
'wishy-washy' alignments, and this can lead to serious disagreements
and apparently arbitrary judgements on the DM's part.  In an attempt
to avoid this I have in the past outlined to my players (usually in
written form, but sometimes verbally) what my concept of alignments
are so that players may play their characters correctly, plus a
description of the penalties that will occur if serious alignment
transgressions are involved.  In most cases, my source of info comes
from Dieties and Demigods (plus the PHB and DMG).  In general, I have
found the 2nd Edition PHB and DMG much more understandable than Mr.
Gygax's attempt at socialogy/philosophy.  The older rules (IMHO)
served to confuse most persons who tried to understand them, and only
made the debate worse.

What follows is my concepts concerning aD&D alignments, which has been
(and will continue to be) the basis of judgements in my campaign.  I
welcome discussion and/or criticisms as I always strive for DM/party
harmony.

			CHARACTER ALIGNMENT DESCRIPTIONS

All aD&D characters have alignments, especially if they progress above
1st level.  Most of a character's inner-strength (i.e. Hit Points, and
Saving Throw abilities) is derived from professing an alignment and
sticking to it.  In a sense, he/she draws energy from the appropriate
HIGHER PLANE (hell, hades, heaven, etc.) with or without the
intervention of a diety (although even if a person doesn't have a
professed deity or religion, much of his luck and higher-level
abilities probably come from SOME entity even though he may not be
aware of it).  In the case of clerics and paladins, this influence is
very strong and obvious.

LAWFUL creatures will tend to be organised, like organisation, and
have a tendency towards heirachy structures, such as ranks, in most of
their dealings.  They will tend to try to co-ordinate their efforts
with others and will in general require like behaviour from their
compatriots.  They will also have a definite set of 'RULES` that they
follow (and depending on the GOOD/EVIL tendencies of the creature will
try to enforce them on others).  Lawfuls will also have a tendency to
follow orders, provided they come from someone they consider to be a
leader type or have higher rank/standing.

CHAOTIC creatures (characters) tend to more individualistic and will
strive for personal freedom.  The concerns for the group (party) will
in most cases be only secondary to their own freedom/interests.  They
will tend to do things without consulting others and will (in general)
distain authority figures (unless they have clearly demonstrated good
leadership) and rule/organisation, seeing it as a threat to their
personal freedom.

NEUTRAL characters (vis a vis the LAW/CHAOS part of alignment) tend to
follow some rules, while ignoring others that they feel are
unnecessary or harsh.  They will be more 'subjective' concerning
co-operation in a party or group.  They will follow
laws/orders/organisational heirachies only if they agree that they are
vital and desirable.

GOOD creatures will (in general) tend to protect the weak or
dis-advantaged, and will be interested in what we commonyl think of as
'human rights' especially the right to life and happiness.  They will
desire overall harmony between peoples, and good relations with other
creatures.  They will in general abhor such things as dishonesty,
cruelty, greed, power-lust, human/creature sacrifices and needless
destruction of property or people (creatures).  Most of us know what
it is to be good (I THINK???).

EVIL creatures are essentially the opposite of GOOD ones.  Depending
on whether they are lawful/chaotic their attitude towords life will
differ.  However, in general, they will hate weak creatures and will
believe that it is their right and indeed task to 'cull' these
weaklings to make room for more desirable creatures (esp. themselves).
They will have no trouble with killing anyone or anything that they
deem as a threat or that which is generally in their way, whether this
is true or not.  They will value terror and fear as an ideal mechanism
to 'pursuade' or extort whatever they want from their victims.  This
is especially true with LEs, as they will in general use these as
`tools' to bring about their ideal of law and order.  Evil creatures
will not be concerned about cruelty, unless it effects them directly
(i.e. a close friend or relative they care about), nor will they mind
dishonesty, again unless it effects them adversely (in which case they
may take rather extreme action against the liar).  They will also be
highly motivated by greed, envy and a lust for power.

NEUTRAL creatures will tend to believe in a balance between extremely
GOOD or righteousness on one hand (i.e. goddamn TV evangelists again!
What, they cancelled Playboy weekend!??) and extreme EVIL on the other
(i.e. why must they kill every plant in the world?  Was it absolutely
necessary to smash that guy's head even after he cooperated with
use?).  They will not be too concerned about methods they use to bring
about their philosophy on life.  True neutrals (NN) will believe in
the inherent nature of the COSMOS to balance itself out.  However,
they will not like it when serious attempts are made to intervene and
change this balance, such as having a major DEMON running about or
having ANGELS or DEVAS flying Combat Air Patrol in the skies above!
Neutrals will be strong believers in natural forces (such as Physical
Laws) and will view the good/evil struggle as an interesting side-show
to the overall scheme of the universe as a cyclic or balanced entity.
They will probably believe in something like DARWINISM as it relates
to strength/weakness.  Neutrals will only take a strong ethical
position if threatened (or alternately, if what they perceive as
universal harmony is threatened, especially if they are true neutrals
(NN).  In the case of CNs, their behaviour could be best described as
random.  You never know exactly what they'll do.  They will sometimes
be good, sometimes bad, and will generally not follow ANY rules.
However, they will never do extremely EVIL (eg. geniocidal type mass
murder) nor extremely RIGHTEOUS (eg. donating huge amounts of money to
charity, helping someone when it threatens his own life) deeds.


I have found it valuable (when describing alignments) to give good
examples of actual creatures/persons in fact or fiction as
illustrations of each of the various alignment types:

LG - The POPE, RC (or Anglican) heirarchy.  KING AUTHUR or any other
'good' king from European history.  GOD (jewish or christian ideal),
JESUS. The Saints. LGs will not be pansies, however, and harsh
punishments for law breakers may not be uncommon.

NG - A typical (good) civilian type, who finds a youth stealing
something or committing a minor crime and gives the youth a scare but
does not turn him into the 'authorities' especially if the
'authorities' are less than fair.  Indiana Jones ('that artifact
belongs in a museum') who, violated certain rules while followed
others, and who still believed in Good behaviour (cf. Temple of Doom
and parts in The Last Crusade).  James T. Kirk, who follows most of
Star Fleets' rules until (or unless) it becomes problematic to his
personal freedom or interests.

CG - Eddie Murphy (Axle Foley in Bevery Hills Cop). Does not follow
the rules but still values goodness.  In fact, most popular movie
heros/heroins tend to protray (what I perceive) CG behaviour.  You
know, personal rights, the fight against injustice, and other popular
'causes' these days.

LN - The typical Policeman/Military Person/Government official, who
simple follow rules, orders and follow laws without much concern for
what they may cause (in terms of Goodness/Evil).  The typical
scientist/professor who is trying to discover some physical or
scientific truth, but completely ignores what the effect of this
knowledge on humanity might be (eg. A-Bomb development) if it falls
into the 'wrong' hands.

LE - The Nazis; thought they were right (and everone else stupid or
wrong) and thought it their right and task to cull the world of those
they considered as useless or weak.  Another (less extreme) group is
the Mafia - follow our rules or suffer the consequencies.  However,
the ideal Nazi (and Modster) was(is) still expected to follow proper
procedure and be loyal to some universal cause.

CE - Demons, serial murderers or crazed killers who show absolutely no
remorse or guilty and whose methods are generally cruel and random.
Mainly concerned with their own self (super selfish) and do not follow
orders or rules of conduct. On a less extreme level, rogue assasins
(those who kill 'just for the fun of it, just for the taste of it!'
and are not a part of any mission or organisation) might be termed CE
in their behaviour.  CNs who aren't careful may tend to drift towards
this alignment, especially if they insist on cruel or arbitrary
behaviour which causes harm.

NE - It has been said that NEs are the worst ones to encounter.  They
(besides being evil) can be unpredictable, as they may follow certain
rules of engagement while violating others.  They will be more or less
self-centred, and will tend to follow their own rules (which will
change in unpredictable ways).  You will not be certain exactly how
they may react or behave.  In some ways, the SHERIFF of NOTTINGHAM in
the recent ROBIN HOOD movie, is a good example of a true NE at work.
He had a tendency to do random things (which were funny) and changed
rules to suit his purposes. However, even at the end, he still wanted
to follow certain rules of behaviour such as lawful marriage inorder
to achieve some element of decency/legitimacy.

CN - MALEK (of Conan movie fame).  Self interested and highly random
in his behaviour.  Yet, he was not evil, nor was he particularly good.

NN - Druids, those who value nature (even above humanity).  A good
REAL are naturalists who go into in seclusion to study some animal
(esp. primates) but eventually reject most of their Western (and
indeed human) ideals in favour of the 'apes' behaviour.  They almost
always say something like 'it is not natural' concerning mankind's
evolution and technological development.  

		DMing and Adjudicating Alignments

The behaviour of a character will be constantly monitored.  What he
says and thinks are important, but what really matters are his deeds.
As the cliche goes, `actions speak louder than words'.  At crucial
points, a character will have to choose between various actions; good
and evil, lawful or chaotic.  How he responds will be judged by the
DM.  In practical terms (such as with the more 'definite alignments
like LG, CG, LE and CE) one should only have to do this every so
often.  However, the more 'wishy-washy' alignments require closer
scrutiny.  In general, a characters current alignment can be 'charted'
on the alignment wheel (at back of Dieties and Demigods and the PHB),
probably stepping towards a particular alignment type with particular
actions.  The more severe the action, the furthur this 'jump' will be.
(I used to keep a copy of the wheel on a piece of cardboard, and had
coloured pins, or flags, marking each character's alignment
'position'.

When a character steps out of his alignment, I usually follow the
following procedure:

1.  Minor transgressions (person bad-mouths his diety or ethos, good
person is negligent when someone else tortures or mistreats
prisoners.)  If this is very infrequent or a first offense, character
gets a warning from the gods, in the form of an ill-omen).  If minor
transgressions are repeated, minor powers of the character will be
affected (-1 to hit for a day, -1 on saves, HPs regenerate at 1/2
normal rate).  Constant violations may cause loss of spells (clerics)
and may require atonement (Paladins in particular).

2. Major transgressions (eg.  Good person tortures a prisoner to
death, acts in a greedy and dishonest manner, chaotic person starts
acting like a soldier or policeman).  These can have two effects.
First, major loss of power (especially if a cleric) should occur.
Person may be unlucky in combat (-2 on hits and saves).  Paladins will
lose their paladinhood.

3.	Repeated violations or really bad transgressions.  If a
character is constantly acting like someone of a different alignment,
the DM must inform them that they have changed alignment.  If a
paladin, it's good-bye paladinship.  If a cleric, the cleric may only
cast 1st or 2nd lvls until he joins another cult.  In a sense, he
becomes a 3rd lvl cleric in the new religion, provided he can convince
the other diety that he is genuine.  ALL CHARACTERS, upon changing
alignment immediately LOSE at least one experience level, as a result
of the loss of his former diety's (or entity's) influence.

Characters must not be allowed to 'alignment shop'.  Repeated changes
of alignment will (and should) cause the character to become a major
nuisance to the gods.  They will probably attempt to do away with the
character (evil or neutral gods in particular) or will simply render
him unable to advance in level ever again.  Involuntary alignment
changes (GEAS or CURSES or CHARMs) will cause a temporary loss of
ability as described in 3. above.  However, proper ATONEMENT (the
spell) will reverse the adverse effects, and my (only if the
character's previous behaviour has been spot-on) bring PALADINSHIP
back.  Of course, one can always use a wish to get back lost
abililities, but such a person will be termed a cheater by the gods
and will most likely be hunted down or at least cursed with bad luck
(-2 on hits).

